
#ifndef _MANAGEMENT_COM_REDHAT_SESAME_SYSIMAGE_
#define _MANAGEMENT_COM_REDHAT_SESAME_SYSIMAGE_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

#include <limits>

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace sesame {


 class Sysimage : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];

    uint8_t presenceMask[1];
    static const uint8_t presenceByte_distro = 0;
    static const uint8_t presenceMask_distro = 1;



    // Properties
    ::qpid::types::Uuid uuid;
    std::string osName;
    std::string nodeName;
    std::string release;
    std::string version;
    std::string machine;
    std::string distro;
    uint32_t memTotal;
    uint32_t swapTotal;

    // Statistics
    uint32_t  memFree;
    uint32_t  swapFree;
    float  loadAverage1Min;
    float  loadAverage5Min;
    float  loadAverage10Min;
    uint32_t  procTotal;
    uint32_t  procRunning;


  public:


     static void writeSchema(std::string& schema);
     void mapEncodeValues(::qpid::types::Variant::Map& map,
                                          bool includeProperties=true,
                                          bool includeStatistics=true);
     void mapDecodeValues(const ::qpid::types::Variant::Map& map);
     void doMethod(std::string&           methodName,
                                   const ::qpid::types::Variant::Map& inMap,
                                   ::qpid::types::Variant::Map& outMap,
                                   const std::string& userId);
     std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


     Sysimage(
        ::qpid::management::ManagementAgent* agent,
        ::qpid::management::Manageable* coreObject, const ::qpid::types::Uuid& _uuid);

     ~Sysimage();

    

     static void registerSelf(
        ::qpid::management::ManagementAgent* agent);

    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_osName (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        osName = val;
        configChanged = true;
    }
    inline const std::string& get_osName() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return osName;
    }
    inline void set_nodeName (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        nodeName = val;
        configChanged = true;
    }
    inline const std::string& get_nodeName() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return nodeName;
    }
    inline void set_release (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        release = val;
        configChanged = true;
    }
    inline const std::string& get_release() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return release;
    }
    inline void set_version (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        version = val;
        configChanged = true;
    }
    inline const std::string& get_version() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return version;
    }
    inline void set_machine (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        machine = val;
        configChanged = true;
    }
    inline const std::string& get_machine() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return machine;
    }
    inline void set_distro (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        distro = val;
        presenceMask[presenceByte_distro] |= presenceMask_distro;
        configChanged = true;
    }
    inline const std::string& get_distro() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return distro;
    }
    inline void clr_distro() {
        presenceMask[presenceByte_distro] &= ~presenceMask_distro;
        configChanged = true;
    }
    inline bool isSet_distro() {
        return (presenceMask[presenceByte_distro] & presenceMask_distro) != 0;
    }
    inline void set_memTotal (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        memTotal = val;
        configChanged = true;
    }
    inline uint32_t get_memTotal() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return memTotal;
    }
    inline void set_swapTotal (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        swapTotal = val;
        configChanged = true;
    }
    inline uint32_t get_swapTotal() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return swapTotal;
    }
    inline void set_memFree (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        memFree = val;
        instChanged = true;
    }
    inline uint32_t get_memFree() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return memFree;
    }
    inline void set_swapFree (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        swapFree = val;
        instChanged = true;
    }
    inline uint32_t get_swapFree() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return swapFree;
    }
    inline void set_loadAverage1Min (float val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        loadAverage1Min = val;
        instChanged = true;
    }
    inline float get_loadAverage1Min() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return loadAverage1Min;
    }
    inline void set_loadAverage5Min (float val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        loadAverage5Min = val;
        instChanged = true;
    }
    inline float get_loadAverage5Min() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return loadAverage5Min;
    }
    inline void set_loadAverage10Min (float val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        loadAverage10Min = val;
        instChanged = true;
    }
    inline float get_loadAverage10Min() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return loadAverage10Min;
    }
    inline void set_procTotal (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        procTotal = val;
        instChanged = true;
    }
    inline uint32_t get_procTotal() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return procTotal;
    }
    inline void set_procRunning (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        procRunning = val;
        instChanged = true;
    }
    inline uint32_t get_procRunning() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return procRunning;
    }



};

}}}}

#endif  /*!_MANAGEMENT_SYSIMAGE_*/
